SystemOrganization addCategory: #'Comet-Examples'!

!GRPackage class methodsFor: '*comet-examples' stamp: 'lr 2/17/2010 15:10'!
cometExamples
	^ self new
		name: 'Comet-Examples';
		description: 'Examples for server push technology.';
		addDependency: 'JQuery-UI';
		addDependency: 'Comet-Core';
		url: #seasideUrl;
		yourself! !

WASession subclass: #CTChatSession
	instanceVariableNames: 'username'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comet-Examples'!

!CTChatSession methodsFor: 'accessing' stamp: 'lr 1/2/2008 18:07'!
username
	^ username! !

!CTChatSession methodsFor: 'accessing' stamp: 'lr 1/2/2008 18:06'!
username: aString
	username := aString! !

GRObject subclass: #CTCounterModel
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comet-Examples'!

!CTCounterModel methodsFor: 'accessing' stamp: 'lr 1/2/2008 16:36'!
count
	^ count! !

!CTCounterModel methodsFor: 'accessing' stamp: 'lr 1/2/2008 16:43'!
count: anInteger
	count := anInteger! !

!CTCounterModel methodsFor: 'actions' stamp: 'lr 1/2/2008 16:33'!
decrease
	count := count - 1! !

!CTCounterModel methodsFor: 'actions' stamp: 'lr 1/2/2008 16:33'!
increase
	count := count + 1! !

!CTCounterModel methodsFor: 'initialization' stamp: 'lr 11/11/2008 22:57'!
initialize
	super initialize.
	count := 0! !

GRObject subclass: #CTReportItem
	instanceVariableNames: 'name phone'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comet-Examples'!

!CTReportItem methodsFor: 'accessing' stamp: 'lr 5/5/2009 21:02'!
name
	^ name! !

!CTReportItem methodsFor: 'accessing' stamp: 'lr 5/5/2009 21:02'!
name: aString
	name := aString! !

!CTReportItem methodsFor: 'accessing' stamp: 'lr 5/5/2009 21:02'!
phone
	^ phone! !

!CTReportItem methodsFor: 'accessing' stamp: 'lr 5/5/2009 21:02'!
phone: aString
	phone := aString! !

WAComponent subclass: #CTChat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comet-Examples'!

CTChat class
	instanceVariableNames: 'pusher'!

CTChat class
	instanceVariableNames: 'pusher'!

!CTChat class methodsFor: 'initialization' stamp: 'lr 6/7/2010 10:59'!
initialize
	| application |
	application := WAAdmin register: self asApplicationAt: 'comet/chat'.
	application preferenceAt: #sessionClass put: CTChatSession.
	application
		addLibrary: JQDeploymentLibrary;
		addLibrary: CTLibrary! !

!CTChat class methodsFor: 'accessing' stamp: 'lr 1/2/2008 17:58'!
pusher
	^ pusher ifNil: [ pusher := CTPusher new ]! !

!CTChat methodsFor: 'testing' stamp: 'lr 1/2/2008 19:00'!
isLoggedIn
	^ self username notNil! !

!CTChat methodsFor: 'actions' stamp: 'lr 1/2/2008 20:01'!
login: aString
	"Join the chat-room with the given username aString."
	
	aString isEmptyOrNil ifTrue: [ ^ self ].
	self session username: aString.
	self push: 'event' with: 'joined'! !

!CTChat methodsFor: 'actions' stamp: 'lr 1/2/2008 20:01'!
logout
	"Leave the chat-room."

	self push: 'event' with: 'left'.
	self session username: nil! !

!CTChat methodsFor: 'actions' stamp: 'lr 1/2/2008 19:35'!
message: aString
	"Send the message aString to the chat-room."
	
	self push: 'message' with: aString! !

!CTChat methodsFor: 'private' stamp: 'lr 11/17/2009 08:32'!
push: aString with: aBlock
	"This code pushes the new message to all its clients. With the exception of part 2 adding the message itself, all other parts are optional."
	
	self pusher javascript: [ :script |
		script add: ((script jQuery: #messages)
		"1. limit listing to 20 messages"
			children;
			sliceFrom: 0 to: -19;
			remove;
			end;
		"2. append message to bottom"
			append: [ :html | self renderMessage: aBlock class: aString on: html ];
			end;
		"3. scroll to bottom"
			scrollTop: 65536) ]! !

!CTChat methodsFor: 'accessing' stamp: 'lr 1/2/2008 18:37'!
pusher
	^ self class pusher! !

!CTChat methodsFor: 'rendering-chat' stamp: 'lr 3/17/2009 20:22'!
renderChatInputOn: html
	html textArea
		id: #input;
		callback: [ :value | self message: value ];
		onEnter: (html jQuery ajax
			onSuccess: ((html jQuery: #input) 
				value: String new);
			serializeThis)! !

!CTChat methodsFor: 'rendering-chat' stamp: 'lr 1/2/2008 20:05'!
renderChatMessagesOn: html
	html div id: 'messages'; with: [
		self 
			renderMessage: [
				self users isEmpty
					ifTrue: [ html text: 'You are the only one here!!' ]
					ifFalse: [
						html text: 'Also there: '.
						self users
							do: [ :each | html text: each ]
							separatedBy: [ html text: ', ' ] ] ]
			class: 'event' on: html ]! !

!CTChat methodsFor: 'rendering' stamp: 'lr 1/2/2008 19:44'!
renderChatOn: html
	self renderChatStatusOn: html.
	self renderChatMessagesOn: html.
	self renderChatInputOn: html.
	self renderChatPusherOn: html! !

!CTChat methodsFor: 'rendering-chat' stamp: 'lr 3/25/2009 08:56'!
renderChatPusherOn: html
	html document 
		addLoadScript: (html comet
			pusher: self pusher;
			connect)! !

!CTChat methodsFor: 'rendering-chat' stamp: 'lr 1/2/2008 19:56'!
renderChatStatusOn: html
	html div id: 'status'; with: [
		html text: 'Currently logged in as ' , self username , '. '.
		html anchor
			callback: [ self logout ];
			with: 'Logout' ]! !

!CTChat methodsFor: 'rendering' stamp: 'lr 1/2/2008 18:38'!
renderContentOn: html
	html heading: 'Seaside Chat'.
	self isLoggedIn
		ifTrue: [ self renderChatOn: html ]
		ifFalse: [ self renderLoginOn: html ]! !

!CTChat methodsFor: 'rendering' stamp: 'lr 1/2/2008 18:52'!
renderLoginOn: html
	html form: [
		html textInput
			value: self username;
			callback: [ :value | self login: value ].
		html submitButton
			text: 'Login' ]! !

!CTChat methodsFor: 'rendering' stamp: 'lr 1/2/2008 20:05'!
renderMessage: aBlock class: aString on: html
	html div class: 'message'; with: [
		html span class: 'user'; with: self username.
		html span class: aString; with: aBlock ]! !

!CTChat methodsFor: 'rendering' stamp: 'lr 1/10/2009 13:36'!
style
	^ 'a {
	color: #00f;
	cursor: pointer;
	text-decoration: underline;	
}
#status {
	background-color: #eee;
}
#messages {
	height: 10em;
	overflow: auto;
}
#messages .message {
	margin-top: 0.25em;
	margin-bottom: 0.25em;
}
#messages .message .user {
	font-weight: bold;
	margin-right: 1em;
}
#messages .message .event {
	font-style: italic;
}
#input {
	width: 100%;
	background-color: #eee;
}'! !

!CTChat methodsFor: 'accessing' stamp: 'lr 1/2/2008 18:38'!
username
	^ self session username! !

!CTChat methodsFor: 'accessing' stamp: 'lr 1/2/2008 20:01'!
users
	^ (self pusher handlers
		reject: [ :each | self session == each session or: [ each session username isNil ] ])
		collect: [ :each | each session username ]! !

WAComponent subclass: #CTCounter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comet-Examples'!

CTCounter class
	instanceVariableNames: 'model pusher'!

CTCounter class
	instanceVariableNames: 'model pusher'!

!CTCounter class methodsFor: 'initialization' stamp: 'lr 8/20/2011 16:58'!
initialize
	| application |
	application := WAAdmin register: self asApplicationAt: 'comet/counter'.
	application addLibrary: JQDeploymentLibrary; addLibrary: CTLibrary! !

!CTCounter class methodsFor: 'accessing' stamp: 'lr 1/2/2008 18:01'!
model
	^ model ifNil: [ model := CTCounterModel new ]! !

!CTCounter class methodsFor: 'accessing' stamp: 'lr 1/2/2008 18:01'!
pusher
	^ pusher ifNil: [ pusher := CTPusher new ]! !

!CTCounter methodsFor: 'actions' stamp: 'lr 1/2/2008 17:08'!
decrease
	self model decrease.
	self update: #decrease! !

!CTCounter methodsFor: 'actions' stamp: 'lr 1/2/2008 17:08'!
increase
	self model increase.
	self update: #increase! !

!CTCounter methodsFor: 'accessing' stamp: 'lr 1/2/2008 16:38'!
model
	^ self class model! !

!CTCounter methodsFor: 'accessing' stamp: 'lr 1/2/2008 16:38'!
pusher
	^ self class pusher! !

!CTCounter methodsFor: 'rendering' stamp: 'lr 3/25/2009 08:56'!
renderContentOn: html
	html heading
		id: #count;
		with: self model count.
	html paragraph: [
		html anchor
			onClick: (html jQuery ajax
				callback: [ self decrease ]);
			with: 'dec'.
		html space; space; space.
		html anchor
			onClick: (html jQuery ajax
				callback: [ self increase ]);
			with: 'inc' ].
	html document 
		addLoadScript: (html comet
			pusher: self pusher;
			connect)! !

!CTCounter methodsFor: 'rendering' stamp: 'lr 7/14/2010 10:06'!
style
	^ 'body {
	color: #222;
	font-size: 4em;
	line-height: 1.5;
	text-align: center;
	font-family: "Helvetica Neue", Helvetica, Verdana, Arial, sans-serif;
}
h1 { font-weight: bold; }
a {
	color: #555;
	cursor: pointer;
	text-decoration: none;	
}'! !

!CTCounter methodsFor: 'private' stamp: 'obi 6/23/2010 19:46'!
update: anAspect
	"Update the number in all connected web browser. Only the first 3 lines are really needed, the rest adds some eye-candy and can simply be removed if not needed."

	self pusher javascript: [ :script |
		script << (script jQuery: #count) 
			text: self model count;
			append: [ :html |
				html span: [
					html html: (anAspect = #increase
						ifTrue: [ '&uarr;' ]
						ifFalse: [ '&darr;' ]) ] ];
			find: 'span'; fadeOut: 'slow' ]! !

WAComponent subclass: #CTReport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comet-Examples'!

CTReport class
	instanceVariableNames: 'items pusher'!

CTReport class
	instanceVariableNames: 'items pusher'!

!CTReport class methodsFor: 'private' stamp: 'lr 5/5/2009 21:05'!
defaultModel
	^ OrderedCollection new
		add: (CTReportItem new
			name: 'Peter Parker';
			phone: '183 045 2037';
			yourself);
		add: (CTReportItem new
			name: 'John Hood';
			phone: '602 979 3001';
			yourself);
		add: (CTReportItem new
			name: 'Clark Kent';
			phone: '497 776 2568';
			yourself);
		add: (CTReportItem new
			name: 'Bruce Evans';
			phone: '167 604 1282';
			yourself);
		yourself! !

!CTReport class methodsFor: 'initialization' stamp: 'lr 6/7/2010 10:59'!
initialize
	| application |
	application := WAAdmin register: self asApplicationAt: 'comet/report'.
	application
		addLibrary: JQDevelopmentLibrary;
		addLibrary: CTLibrary! !

!CTReport class methodsFor: 'accessing' stamp: 'lr 5/5/2009 21:05'!
items
	^ items ifNil: [ items := self defaultModel ]! !

!CTReport class methodsFor: 'accessing' stamp: 'lr 5/5/2009 20:58'!
pusher
	^ pusher ifNil: [ pusher := CTPusher new ]! !

!CTReport methodsFor: 'accessing' stamp: 'lr 5/5/2009 21:10'!
items
	^ self class items! !

!CTReport methodsFor: 'accessing' stamp: 'lr 5/5/2009 21:23'!
pusher
	^ self class pusher! !

!CTReport methodsFor: 'rendering' stamp: 'lr 10/9/2010 11:05'!
renderAddOn: html
	html anchor
		url: '#';
		" append a new row to the table "
		onClick: (html jQuery ajax script: [ :script |
			script add: ((script jQuery: 'table') append: [ :renderer |
				renderer tableRow: [
					self
						renderRowEdit: CTReportItem new
						action: [ :item | self items add: item ]
						on: renderer ] ]) ]);
		with: 'Add Item'! !

!CTReport methodsFor: 'rendering' stamp: 'lr 10/9/2010 10:49'!
renderContentOn: html
	html table
		script: (html jQuery this
			bind: 'refresh' do: (html jQuery this load
				html: [ :h | self renderTableOn: h ]));
		with: [ self renderTableOn: html ].
	html paragraph: [
		self renderAddOn: html ].
	html document 
		addLoadScript: (html comet
			pusher: self pusher;
			connect)! !

!CTReport methodsFor: 'rendering' stamp: 'lr 10/9/2010 10:54'!
renderRowEdit: anItem action: aBlock on: html
	html tableData: [ 
		html textInput
			" focus the first input field "
			script: (html jQuery this triggerFocus);
			on: #name of: anItem ].
	html tableData: [ 
		html textInput 
			on: #phone of: anItem ].
	html tableData: [
		html anchor
			url: '#';
			onClick: (html jQuery ajax
				" serialize all form elements in the table "
				serialize: ((html jQuery this closest: 'table') find: ':input');
				" trigger a refresh on all connected tables "
				html: [ :r |
					aBlock value: anItem.
					self pusher javascript: [ :s |
						s add: ((s jQuery: 'table') 
							trigger: 'refresh') ] ]);
			with: 'save' ]! !

!CTReport methodsFor: 'rendering' stamp: 'lr 10/9/2010 11:03'!
renderRowEdit: anItem on: html
	self renderRowEdit: anItem action: [ :item | ] on: html! !

!CTReport methodsFor: 'rendering' stamp: 'lr 5/5/2009 21:23'!
renderRowView: anItem on: html
	html tableData: anItem name.
	html tableData: anItem phone.
	html tableData: [
		html anchor
			url: '#';
			" replace the owning row with an editable row "
			onClick: ((html jQuery this closest: 'tr') load
				html: [ :r | self renderRowEdit: anItem on: r ]);
			with: 'edit' ]! !

!CTReport methodsFor: 'rendering' stamp: 'lr 5/5/2009 21:20'!
renderTableOn: html
	html tableRow: [
		html tableHeading: 'Name'.
		html tableHeading: 'Phone'.
		html tableHeading ].
	self items do: [ :each |
		html tableRow: [
			self renderRowView: each on: html ] ]! !

WAComponent subclass: #CTSlider
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comet-Examples'!

CTSlider class
	instanceVariableNames: 'value pusher'!

CTSlider class
	instanceVariableNames: 'value pusher'!

!CTSlider class methodsFor: 'initialization' stamp: 'lr 8/20/2011 16:59'!
initialize
	| application |
	application := WAAdmin register: self asApplicationAt: 'comet/slider'.
	application 
		addLibrary: JQDevelopmentLibrary;
		addLibrary: JQUiDevelopmentLibrary;
		addLibrary: JQSmoothnessTheme;
		addLibrary: CTLibrary! !

!CTSlider class methodsFor: 'accessing' stamp: 'lr 7/12/2009 17:08'!
pusher
	^ pusher ifNil: [ pusher := CTPusher new ]! !

!CTSlider class methodsFor: 'accessing' stamp: 'lr 7/12/2009 17:20'!
value
	^ value ifNil: [ value := 50 ]! !

!CTSlider class methodsFor: 'accessing' stamp: 'lr 7/12/2009 17:42'!
value: aNumber
	value := aNumber.
	self pusher javascript: [ :script |
		script << (script jQuery: #slider) slider
			action: 'value'
			arguments: (Array with: value) ]! !

!CTSlider methodsFor: 'rendering' stamp: 'lr 8/11/2009 10:45'!
renderContentOn: html
	html div
		id: #slider;
		script: (html jQuery new slider
			value: self class value;
			onStop: (html jQuery ajax
				callback: [ :value | self class value: value asNumber ]
				value: (html jQuery this slider getValue))).
	html document
		addLoadScript: (html comet
			pusher: self class pusher;
			connect)! !
CTChat initialize!
CTCounter initialize!
CTReport initialize!
CTSlider initialize!
